stages:
 - build
 - release

build:windows:
  stage: build
  tags:
  - windows
  when: manual
  script:
    - choco install -y cmake --installargs '"ADD_CMAKE_TO_PATH=System"'
    - $env:Path += ";C:\Program Files\CMake\bin"
    - cmake . -DCMAKE_TOOLCHAIN_FILE="$TOOLCHAIN.cmake"
    - cmake --build . --config Release
    - cp Release/$CI_PROJECT_TITLE.*.dll ./
  after_script:
    - $env = "${TOOLCHAIN}_JOB_ID=$CI_JOB_ID" -replace "-", "_"
    - Add-Content -Path job.env -Value $env
  parallel:
    matrix:
      - TOOLCHAIN: [windows-x86, windows-x64]
  artifacts:
    name: $CI_PROJECT_TITLE
    paths:
    - $CI_PROJECT_TITLE.*.dll
    expire_in: never
    reports:
       dotenv: job.env
    
release:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  when: manual
  needs: [build:windows]
  variables:
    TAG: '0.1'
  script:
    - echo "Create Release $TAG"
  release:
    tag_name: '$TAG'
    description: "./CHANGELOG.md"
    assets:
      links:
        - name: "$CI_PROJECT_TITLE.x86.dll"
          url: "$CI_PROJECT_URL/-/jobs/$windows_x86_JOB_ID/artifacts/download"
          link_type: "package"
        - name: "$CI_PROJECT_TITLE.x64.dll"
          url: "$CI_PROJECT_URL/-/jobs/$windows_x64_JOB_ID/artifacts/download"
          link_type: "package"

